﻿using System.Collections.Generic;

using Microsoft.Msagl.Prototype.Phylo;

using DevExpress.Diagram.Core;
using DevExpress.Diagram.Core.Layout;

namespace TestLibrary
{
    /// <summary>
    /// PHYLO 트리 레이아웃
    /// </summary>
    public class PhyloTreeLayout : GraphLayout
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 트리 - Tree

        /// <summary>
        /// 트리
        /// </summary>
        private PhyloTree Tree { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - PhyloTreeLayout(layoutCalculator)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="layoutCalculator">레이아웃 계산기</param>
        public PhyloTreeLayout(ILayoutCalculator layoutCalculator) : base(layoutCalculator)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 그래프 노드 위치 레이아웃 다시 설정하기 - RelayoutGraphNodePosition(graph)

        /// <summary>
        /// 그래프 노드 위치 레이아웃 다시 설정하기
        /// </summary>
        /// <param name="graph">그래프</param>
        /// <returns>위치 정보 열거 가능 목록</returns>
        public override IEnumerable<PositionInfo<IDiagramItem>> RelayoutGraphNodePosition(Graph<IDiagramItem> graph)
        {
            Tree = MSAGLGeometryGraphHelper.GetPhyloTree(graph);

            LayoutCalculator.CalculateLayout(Tree);

            return MSAGLGeometryGraphHelper.GetNodePositionInfo(Tree);
        }

        #endregion
    }
}