﻿using Microsoft.Msagl.Core.Layout;

namespace TestLibrary
{
    /// <summary>
    /// 레이아웃 계산기 인터페이스
    /// </summary>
    public interface ILayoutCalculator
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property

        #region 레이아웃 알고리즘 설정 - LayoutAlgorithmSettings

        /// <summary>
        /// 레이아웃 알고리즘 설정
        /// </summary>
        LayoutAlgorithmSettings LayoutAlgorithmSettings { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 레이아웃 계산하기 - CalculateLayout(geometryGraph)

        /// <summary>
        /// 레이아웃 계산하기
        /// </summary>
        /// <param name="geometryGraph">기하 그래프</param>
        void CalculateLayout(GeometryGraph geometryGraph);

        #endregion
    }
}