﻿using System;

using Microsoft.Msagl.Core.Geometry.Curves;
using Microsoft.Msagl.Core.Layout;
using Microsoft.Msagl.Core.Routing;
using Microsoft.Msagl.Layout.Layered;
using Microsoft.Msagl.Miscellaneous;

namespace TestLibrary
{
    /// <summary>
    /// SUGIYAMA 레이아웃 계산기
    /// </summary>
    public class SugiyamaLayoutCalculator : ILayoutCalculator
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 레이아웃 알고리즘 설정 - LayoutAlgorithmSettings

        /// <summary>
        /// 레이아웃 알고리즘 설정
        /// </summary>
        public LayoutAlgorithmSettings LayoutAlgorithmSettings
        {
            get
            {
                return new SugiyamaLayoutSettings()
                {
                    NodeSeparation      = 30,
                    Transformation      = PlaneTransformation.Rotation(Math.PI / 2),
                    EdgeRoutingSettings = { EdgeRoutingMode = EdgeRoutingMode.SugiyamaSplines }
                };
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 레이아웃 계산하기 - CalculateLayout(geometryGraph)

        /// <summary>
        /// 레이아웃 계산하기
        /// </summary>
        /// <param name="geometryGraph">기하 그래프</param>
        public void CalculateLayout(GeometryGraph geometryGraph)
        {
            LayoutHelpers.CalculateLayout( geometryGraph, LayoutAlgorithmSettings, null);
        }

        #endregion
    }
}