﻿using Microsoft.Msagl.Core.Routing;

using DevExpress.Diagram.Core;

namespace TestLibrary
{
    /// <summary>
    /// 라우팅 헬퍼
    /// </summary>
    public static class RoutingHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 다이어그램 커넥터 타입 구하기 - GetDiagramConnectorType(routingMode)

        /// <summary>
        /// 다이어그램 커넥터 타입 구하기
        /// </summary>
        /// <param name="routingMode">라우팅 모드</param>
        /// <returns>다이어그램 커넥터 타입</returns>
        public static ConnectorType GetDiagramConnectorType(EdgeRoutingMode routingMode)
        {
            if(routingMode == EdgeRoutingMode.StraightLine)
            {
                return ConnectorType.Straight;
            }
            else if
            (
                routingMode == EdgeRoutingMode.Spline         ||
                routingMode == EdgeRoutingMode.SplineBundling ||
                routingMode == EdgeRoutingMode.SugiyamaSplines
            )
            {
                return ConnectorType.Curved;
            }
            else
            {
                return ConnectorType.RightAngle;
            }
        }

        #endregion
    }
}