﻿using System;
using System.Linq;
using System.Windows.Forms;

using DevExpress.Diagram.Core;
using DevExpress.Diagram.Core.Layout;
using DevExpress.XtraBars;
using DevExpress.XtraEditors;

using TestLibrary;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.loadSugiyamaLayoutBarButtonItem.ItemClick           += loadSugiyamaLayoutBarButtonItem_ItemClick;
            this.applySugiyamaLayoutBarButtonItem.ItemClick          += applySugiyamaLayoutBarButtonItem_ItemClick;
            this.loadDisconnectedGraphLayoutBarButtonItem.ItemClick  += loadDisconnectedGraphLayoutBarButtonItem_ItemClick;
            this.applyDisconnectedGraphLayoutBarButtonItem.ItemClick += applyDisconnectedGraphLayoutBarButtonItem_ItemClick;
            this.loadPhyloTreeLayoutBarButtonItem.ItemClick          += loadPhyloTreeLayoutBarButtonItem_ItemClick;
            this.applyPhyloTreeLayoutBarButtonItem.ItemClick         += applyPhyloTreeLayoutBarButtonItem_ItemClick;
            this.loadRankingLayoutBarButtonItem.ItemClick            += loadRankingLayoutBarButtonItem_ItemClick;
            this.applyRankingLayoutBarButtonItem.ItemClick           += applyRankingLayoutBarButtonItem_ItemClick;
            this.loadMDSLayoutBarButtonItem.ItemClick                += loadMDSLayoutBarButtonItem_ItemClick;
            this.applyMDSLayoutBarButtonItem.ItemClick               += applyMDSLayoutBarButtonItem_ItemClick;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region SUGIYAMA 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기 - loadSugiyamaLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// SUGIYAMA 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void loadSugiyamaLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            this.diagramControl.LoadDocument("DATA/SugiyamaLayout.xml");
        }

        #endregion
        #region SUGIYAMA 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기 - applySugiyamaLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// SUGIYAMA 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void applySugiyamaLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            ApplyLayout(new GraphLayout(new SugiyamaLayoutCalculator()));
        }

        #endregion
        #region 비연결 그래프 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기 - loadDisconnectedGraphLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// 비연결 그래프 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void loadDisconnectedGraphLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            this.diagramControl.LoadDocument("DATA/DisconnectedGraphLayout.xml");
        }

        #endregion
        #region 비연결 그래프 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기 - applyDisconnectedGraphLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// 비연결 그래프 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void applyDisconnectedGraphLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            ApplyLayout(new GraphLayout(new DisconnectedGraphsLayoutCalculator()));
        }

        #endregion
        #region PHYLO 트리 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기 - loadPhyloTreeLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// PHYLO 트리 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void loadPhyloTreeLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            this.diagramControl.LoadDocument("DATA/PhyloTreeLayout.xml");
        }

        #endregion
        #region PHYLO 트리 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기 - applyPhyloTreeLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// PHYLO 트리 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void applyPhyloTreeLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            ApplyLayout(new PhyloTreeLayout(new PhyloTreeLayoutCalculator()));
        }

        #endregion
        #region 랭킹 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기 - loadRankingLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// 랭킹 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void loadRankingLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            this.diagramControl.LoadDocument("DATA/RankingLayout.xml");
        }

        #endregion
        #region 랭킹 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기 - applyRankingLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// 랭킹 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void applyRankingLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            ApplyLayout(new GraphLayout(new RankingLayoutCalculator()));
        }

        #endregion
        #region MDS 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기 - loadMDSLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// MDS 레이아웃 로드 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void loadMDSLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            this.diagramControl.LoadDocument("DATA/MDSLayout.xml");
        }

        #endregion
        #region MSD 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기 - applyMDSLayoutBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// MSD 레이아웃 적용 BAR 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void applyMDSLayoutBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            ApplyLayout(new GraphLayout(new MDSLayoutCalculator()));
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 레이아웃 적용하기 - ApplyLayout(layout)

        /// <summary>
        /// 레이아웃 적용하기
        /// </summary>
        /// <param name="layout">레이아웃</param>
        private void ApplyLayout(GraphLayout layout)
        {
            try
            {
                this.diagramControl.RelayoutDiagramItems
                (
                    layout.RelayoutGraphNodePosition(GraphOperations.GetDiagramGraph(diagramControl))
                );

                foreach(IDiagramConnector connector in this.diagramControl.Items.OfType<IDiagramConnector>())
                {
                    connector.Type = layout.GetDiagramConnectorType();

                    connector.UpdateRoute();
                };

                diagramControl.FitToDrawing();
            }
            catch(Exception exception)
            {
                XtraMessageBox.Show
                (
                    this,
                    string.Format("에러 메시지 : '{0}'", exception.Message),
                    "ERROR",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                );
            }
        }

        #endregion
    }
}